image: registry.gitlab.com/clarin-eric/build-image:1.3.4
services:
  - name: docker:24.0.1-dind

variables:
  GIT_SUBMODULE_STRATEGY: recursive
  DOCKER_DRIVER: overlay2
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_CERTDIR: "/certs"
  DOCKER_TLS_VERIFY: 1
  DOCKER_CERT_PATH: "$DOCKER_TLS_CERTDIR/client"

stages:
  - lint
  - build
  - test
  - security
  - release

lint-dockerfile:
  stage: lint
  script: timeout 1440 bash -x ./build.sh --lint-docker

shell-check:
  stage: lint
  script: timeout 1440 bash -x ./build.sh --lint-shell

build:
  artifacts:
    untracked: true
  script: timeout 1440 bash -x ./build.sh --build
  stage: build
  tags:
    - docker

static-vulnerability-scan:
  dependencies:
    - build
# Uncomment to run security scan only for releases
#  only:
#    - tags
#    - triggers
  script: timeout 1440 bash -x ./build.sh --scan
  stage: security
# Change to allow scan to fail but still continue with the pipeline:
  allow_failure: false
  tags:
    - docker

# Default http test for all images descending from CLARIN docker Alpine Supervisor base image
# Add/remove http(s) tests in checker.conf Format: <URL>;<Expected_HTTP_Status_Code>
# Add one test per line
# Remove or adapt for different image styles
test:
  dependencies:
    - build
  script: timeout 1440 bash -x ./build.sh --test
  stage: test
  tags:
    - docker

release:
  only:
    - tags
    - triggers
  script: timeout 1440 bash -x ./build.sh --release
  stage: release
  tags:
    - docker
